/*  
 *  hello-1.c - The simplest kernel module.
 */
#include <linux/module.h>	/* Needed by all modules */
#include <linux/kernel.h>	/* Needed for KERN_INFO */
#include <linux/init.h> 
#include <linux/moduleparam.h>

MODULE_LICENSE("Dual BSD/GPL");
static char *banana = "ananas";
module_param(banana, charp, S_IRUGO);
int init_module(void)
{
	
	printk(KERN_INFO "Hello world INFO %s.\n", banana);
	printk(KERN_CRIT "Hello world CRIT %s.\n", banana);
	printk(KERN_DEBUG "Hello world DEBUG %s.\n", banana);
	printk(KERN_NOTICE "Hello world NOTICE %s.\n", banana);
	printk(KERN_ALERT "Hello world ALERT %s.\n", banana);
	printk(KERN_WARNING "Hello world WARNING %s.\n", banana);
	printk(KERN_ERR "Hello world ERR %s.\n", banana);
	printk(KERN_EMERG "Hello world EMERG %s.\n", banana);
	
	/* 
	 * A non 0 return means init_module failed; module can't be loaded. 
	 */
	return 0;
}

void cleanup_module(void)
{
	printk(KERN_INFO "Goodbye world 1.\n");
}
